# Contributing to XuperUnion


Thank you for considering contributing to XuperUnion!

## Reporting issues
XuperUnion using github issue to track `bugs` and `feature requests`. Before you opening an issue, please search firstly to make sure there isn't any duplicate or similar issues in issue tracker.

For opening an issue, please describe your situation using our issue template with logs or other clues.

* Your Environment. XuperUnion and OS/Go/gcc version etc.
* Brief of the issue.
* Describe what you expected to happen.
* Describe what actually happened. Include the full traceback if there was an exception.
* If possible, include a minimal, complete, and verifiable example to help us identify the issue. This also helps check that the issue is not with your own code.

## Submit your code
XuperUnion accept code using standard github PR(Pull Request) workflow. Please fork, fix, commit and send a PR for the maintainers to review and merge into the main code base.

Please submit pull request using the following template:

* What is the purpose of the change
* Brief of your solution

Please also include a github issue link of the PR. The PR must pass the CI verification and will be reviewed by the maintainers.

**Note:** Code must adhere to the official Go formatting guidelines(i.e. uses gofmt and golint)

## Sign the Contributor License Agreement
We appreciate community contributions to code repositories open sourced by XuperChain. By signing a contributor license agreement, we ensure that the community is free to use your contributions.

You can review the [XuperChain Contributor License Agreement](https://cla-assistant.io/xuperchain/xuperunion) and sign the CLA before submitting your PR.

Active contributors might be asked to join the core contributor team, and given the ability to merge pull requests.
